/*
    Blacky's IPIP-Tunnel over SSH

    Diese Programm koppelt die Ein- und Ausgaben eines Programmes mit
    einem TTY-Device.

    Gedacht ist dieses Programm um PPP over SSH zu fahren.

    Copyright (c) Andreas Hofmeier

    Dieses Programm ermglicht es (wenn ntig, eine Verschlsselte)
    Verbindung zu einem Server zu erzeugen. ber die Verbindung kann
    man eine andere IP einnehmen (auch wenn man hinter einem Firewall
    oder Masquerading-Server sitzt).

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/


*/


#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
//#include <varargs.h>
#include <stdarg.h>
#include <sys/socket.h>
#include <signal.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/wait.h>

#include "hofmeier.h"


/* function zum Herunterfahren ! */
static void finish(int sig);


// Diese Zeile nochmal in tunnel.c kopieren, damit es get_internet auch schnallt!
char blacky_ver_info[] = "Blacky's Socket-TTY v0.10 (c) Copyright 1999-2001 Andreas Hofmeier";


int hp, hp2, fd, sock;
char ptydev[20], ttydev[20];
int i;
#define BUFFSIZE 3000000
int BUFFSIZE_MODEM = BUFFSIZE;
FILE *modem;


char s[BUFFSIZE];


main(argc, argv)
  int argc;
  char *argv[];
{
  char help = 0;

  if (argc < 3) {
    help = 1;
  }

  if (help == 1) {
    printf(
"/blacky/vt/tnl <Command to Connect> <PPP-Command>\n\n");
    exit(0);
  }


  /* Interrups vergeben ... */
  signal(SIGHUP, finish);       /* 01  /  hangup     - Alt-F4                            */
  signal(SIGINT, finish);       /* 02  /  Interrupt  - ^C                                */
  signal(SIGQUIT, finish);      /* 03  /  Quit                                           */
  signal(SIGTERM, finish);      /* 15  /  Terminierung                                   */

  /* ############# OPEN TTY ############# */
  if ((fd = blacky_gettty(ttydev, ptydev)) < 0) {
    fprintf(stderr, "** FEHLER: Konnte keinen TTY ffnen! (Dieses Programm mu unter root laufen)!\n");
    exit(1);
  }
  if(!fork()) {
    if (fcntl(fd, F_SETFD, 0) == -1) {
      perror("fcntl(..., F_SETFD, 0);");
    }

    if (dup2(fd, 0) == -1) {
      perror("dup2();");
    }
    if (dup2(fd, 1) == -1) {
      perror("dup2();");
    }
    if (dup2(fd, 2) == -1) {
      perror("dup2();");
    }

    system(argv[1]);
    close(fd);
  }
  close(fd);
  /* Starte Programm... */
  sprintf(s, argv[2], ttydev);
  system(s);
  /*Kind-Killen*/
  /*  sleep(5);
  kill(hp, 15);
  kill(hp2, 15);
  sleep(5);
  kill(hp, 9);
  kill(hp2, 9);*/

  exit(0);
}


static void finish(int sig)
{
  sprintf(s, "kill $(ps axwww | grep %s | awk \'{print $1}\') 2> /dev/null", ttydev);
  system(s);
  sprintf(s, "sleep 30; kill $(ps axwww | grep %s | awk \'{print $1}\')  2> /dev/null &", ttydev);
  system(s);
  /* Wenn Programm beendet ist, sich selbst killen... */
  sleep(1);
  kill(hp, 15);
  kill(hp2, 15);
  sleep(5);
  kill(hp, 9);
  kill(hp2, 9);
  exit(0);
}
